<?php

namespace App\Console\Commands\Debug;

use Ensi\LaravelEnsiFilesystem\EnsiStorageFacade;
use Illuminate\Console\Command;

class DebugFilesystem extends Command
{
    /** @var string */
    protected $signature = 'debug:filesystem {cmd} {args?*}';
    /** @var string */
    protected $description = 'Отладка работы файловой системы';

    public function handle()
    {
        $command = $this->argument('cmd');
        $args = $this->argument('args') ?? [];

        switch ($command) {
            case 'put':
                $this->checkArgsCount($args, 2);
                [$src, $dst] = $args;

                if (file_exists($src)) {
                    $file = fopen($src, 'r');
                    EnsiStorageFacade::public()->put($dst, $file);
                    fclose($file);
                }

                break;
            case 'url':
                $this->checkArgsCount($args, 1);
                [$path] = $args;
                echo EnsiStorageFacade::public()->url($path), "\n";

                break;
        }
    }

    private function checkArgsCount(array $args, int $argsCount): void
    {
        if (count($args) < $argsCount) {
            throw new \InvalidArgumentException("Command requires at least {$argsCount} arguments");
        }
    }
}
