<?php

namespace App\Core\Elastic\Category;

use App\Core\Elastic\IndexFactory;
use App\Core\Elastic\Scheduler;
use App\Core\Elastic\ScheduleRunner;
use App\Domain\Categories\Models\Category;

class CategoryScheduler implements Scheduler
{
    public function scheduleAll(ScheduleRunner $scheduleRunner): void
    {
        Category::query()
            ->select(['id'])
            ->chunk(500, function ($products) use ($scheduleRunner) {
                /** @var Category[] $product */
                foreach ($products as $product) {
                    $scheduleRunner->markForIndex(IndexFactory::TYPE_CATEGORY, $product->id);
                }
            });
    }
}
