<?php

namespace App\Core\Elastic\Product\Indexing;

use Exception;
use Illuminate\Support\Collection;

trait ProcessesTicket
{
    protected function forEachTicket(Collection $tickets, callable $action): void
    {
        /** @var ProductTicket $ticket */
        foreach ($tickets as $ticket) {
            if ($ticket->isFailed) {
                continue;
            }

            try {
                $action($ticket);
            } catch (Exception $exception) {
                $ticket->fail($exception);
            }
        }
    }
}
