<?php

namespace App\Core\Elastic\Product;

class ProductIndexOperation
{
    public function __construct(public int $id, public string $name, public ?ProductIndexRecord $data)
    {
    }

    public function encode(string $indexName): array
    {
        $parts = [
            [$this->name => ['_index' => $indexName, '_id' => $this->id]],
        ];

        if ($this->data !== null) {
            $parts[] = $this->data->toArray();
        }

        return $parts;
    }
}
