<?php

namespace App\Core\Elastic\Product;

use App\Core\Elastic\IndexFactory;
use App\Core\Elastic\Scheduler;
use App\Core\Elastic\ScheduleRunner;
use App\Domain\Products\Models\Product;

class ProductScheduler implements Scheduler
{
    public function scheduleAll(ScheduleRunner $scheduleRunner): void
    {
        Product::query()
            ->select(['id'])
            ->chunk(500, function ($products) use ($scheduleRunner) {
                /** @var Product[] $product */
                foreach ($products as $product) {
                    $scheduleRunner->markForIndex(IndexFactory::TYPE_PRODUCT, $product->id);
                }
            });
    }
}
