<?php

namespace App\Domain\Classifiers\Actions\Brands;

use App\Domain\Classifiers\Events\BrandActivityChanged;
use App\Domain\Classifiers\Models\Brand;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

/**
 * @extends AppliesToAggregate<Brand>
 */
class PatchBrandAction
{
    use AppliesToAggregate;

    public function execute(int $brandId, array $fields): Brand
    {
        $brand = $this->patch($brandId, $fields);

        if ($brand->isActivityChanged()) {
            BrandActivityChanged::dispatch($brand->id, $brand->is_active);
        }

        return $brand;
    }

    protected function createModel(): Model
    {
        return new Brand();
    }
}
