<?php

namespace App\Domain\Products\Actions\Products;

use App\Domain\Classifiers\Enums\ProductStatus;
use App\Domain\Products\Models\Product;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class DeleteProductAction
{
    use AppliesToAggregate;

    public function execute(int $productId): void
    {
        $this->patch($productId, ['status_id' => ProductStatus::DELETED]);
    }

    protected function createModel(): Model
    {
        return new Product();
    }
}
