<?php

namespace App\Domain\Products\Actions\Products;

use App\Domain\Products\Models\Product;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

/**
 * @extends AppliesToAggregate<Product>
 */
class ReplaceProductAction
{
    use AppliesToAggregate;

    public function __construct(private SetProductDataAction $productAction)
    {
    }

    public function execute(int $productId, array $fields): Product
    {
        return $this->apply($productId, function (Product $product) use ($fields) {
            $this->productAction->execute($product, $fields, true);

            return $product;
        });
    }

    protected function createModel(): Model
    {
        return new Product();
    }
}
