<?php

namespace App\Domain\Products\Actions\Publication;

use App\Domain\Products\Models\Product;
use App\Domain\Products\Publication\Data\ProductAggregate;
use App\Domain\Products\Publication\ProductPublisher;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class VerifyProductAction
{
    use AppliesToAggregate;

    public function __construct(private readonly ProductPublisher $publisher)
    {
    }

    public function execute(int $productId): void
    {
        $this->apply($productId, function (Product $product) {
            $this->publisher->verify(ProductAggregate::fromDraft($product));
        });
    }

    protected function createModel(): Model
    {
        return new Product();
    }
}
