<?php

namespace App\Domain\Products\Models;

use App\Domain\Support\Models\Model;

/**
 * Опубликованная картинка товара.
 *
 * @property int $product_id Идентификатор товара
 * @property int $sort Порядок сортировки
 * @property string|null $file Файл картинки
 * @property string|null $url URL внешнего файла
 * @property string|null $name Описание картинки
 */
class PublishedImage extends Model
{
    // Идентификатор такой же как у картинки источника
    public $incrementing = false;

    protected $casts = [
        'product_id' => 'int',
        'sort' => 'int',
    ];
}
