<?php

use App\Domain\Products\Models\Product;
use App\Http\ApiV1\Support\Tests\ApiV1ComponentTestCase;

use function Pest\Laravel\getJson;
use function Pest\Laravel\postJson;

uses(ApiV1ComponentTestCase::class)->group('products', 'component');

test('POST /api/v1/products/published:search 200', function () {
    $product = Product::factory()->createOne();

    postJson('/api/v1/products/published:search')
        ->assertStatus(200)
        ->assertJsonCount(1, 'data')
        ->assertJsonPath('data.0.id', $product->id);
});

test('GET /api/v1/products/published/{id} 200', function () {
    $product = Product::factory()->createOne();

    getJson("/api/v1/products/published/{$product->id}")
        ->assertStatus(200)
        ->assertJsonStructure(['data' => ['id', 'name', 'code', 'main_image']])
        ->assertJsonPath('data.id', $product->id);
});

test('GET /api/v1/products/published/{id} 404', function () {
    getJson('/api/v1/products/published/100000')
        ->assertStatus(404);
});
