<?php

namespace Database\Factories\Classifiers;

use App\Domain\Classifiers\Models\Manufacturer;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method Manufacturer createOne(array $fields = [])
 * @method Manufacturer makeOne(array $fields = [])
 * @method Manufacturer|Manufacturer[]|Collection create(array $fields = [], $parent = null)
 */
class ManufacturersFactory extends Factory
{
    protected $model = Manufacturer::class;

    /**
     * @inheritDoc
     */
    public function definition(): array
    {
        return [
            'code' => $this->faker->slug,
            'name' => $this->faker->sentence(2),
        ];
    }
}
