<?php

namespace Database\Factories\Classifiers;

use App\Domain\Classifiers\Models\ProductType;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method ProductType createOne(array $fields = [])
 * @method ProductType makeOne(array $fields = [])
 * @method ProductType|ProductType[]|Collection create(array $fields = [], $parent = null)
 */
class ProductTypesFactory extends Factory
{
    protected $model = ProductType::class;

    /**
     * @inheritDoc
     */
    public function definition(): array
    {
        return [
            'code' => $this->faker->slug,
            'name' => $this->faker->sentence(2),
        ];
    }
}
