<?php

namespace Tests\Integration\Domain\Support\Pagination;

use App\Http\ApiV1\Support\Pagination\PageBuilderFactory;
use Illuminate\Database\Query\Builder;
use Illuminate\Http\Request;
use Mockery\MockInterface;
use Tests\TestCase;

abstract class AbstractPaginationTest extends TestCase
{
    protected function cpbMakeRequest(?array $requestBody = null): Request
    {
        $request = new Request();
        if ($requestBody) {
            $request->setMethod('POST');
            $request->request->add($requestBody);
        }

        return $request;
    }

    public function ofbMakeRequest(?array $requestBody = null): Request
    {
        $request = new Request();
        if ($requestBody) {
            $request->setMethod('POST');
            $request->request->add($requestBody);
        }

        return $request;
    }

    protected function mockQueryBuilder(): MockInterface|Builder
    {
        return $this->mock(Builder::class);
    }

    public function builderFromQuery(?array $requestBody = null)
    {
        $request = new Request();
        if ($requestBody) {
            $request->setMethod('POST');
            $request->request->add($requestBody);
        }

        return (new PageBuilderFactory())->fromQuery(resolve(Builder::class), $request);
    }
}
