<?php

namespace Tests\Integration\Domain\Support\Pagination;

use App\Http\ApiV1\OpenApiGenerated\Enums\PaginationTypeEnum;
use App\Http\ApiV1\Support\Pagination\CursorPageBuilder;
use App\Http\ApiV1\Support\Pagination\OffsetPageBuilder;

class PageBuilderFactoryTest extends AbstractPaginationTest
{
    public function testCursorConfigType()
    {
        config(['pagination.default_type' => PaginationTypeEnum::CURSOR]);

        $pageBuilder = $this->builderFromQuery();

        expect($pageBuilder)->toBeInstanceOf(CursorPageBuilder::class);
    }

    public function testOffsetConfigType()
    {
        config(['pagination.default_type' => PaginationTypeEnum::OFFSET]);

        $pageBuilder = $this->builderFromQuery();

        expect($pageBuilder)->toBeInstanceOf(OffsetPageBuilder::class);
    }
}
