<?php

namespace Tests\Integration\Elastic\Products\Stages;

use App\Core\Elastic\Product\Indexing\PipelineStageInterface;
use App\Core\Elastic\Product\Indexing\ProductTicket;
use App\Domain\Products\Models\Product;
use Illuminate\Foundation\Testing\DatabaseTransactions;
use Illuminate\Support\Collection;
use Tests\TestCase;

abstract class StageTestCase extends TestCase
{
    use DatabaseTransactions;

    /**
     * @return Collection|TestProductTicket[]
     */
    protected function execute(PipelineStageInterface $stage, array $productIds): Collection
    {
        $tickets = ProductTicket::load($productIds);

        $stage->execute($tickets);

        return $tickets->mapInto(TestProductTicket::class);
    }

    protected function executeOne(PipelineStageInterface $stage, Product|int $product): TestProductTicket
    {
        $productId = is_object($product) ? $product->id : $product;

        return $this->execute($stage, [$productId])->first();
    }
}
